package transforms.fft;

//Title:        2-d mixed radix FFT.
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Dongyan Wang
//Company:      University of Wisconsin-Milwaukee.
//Description:
//              . Use FFT1d to perform FFT2d.


public class FFT2d {

  // Input of FFT, 2-d matrix.
  double dataRe[][], dataIm[][];

  // dimx and dimy of 2-d matrix inputRe or inputIm.
  int dimx, dimy;

  // Constructor: 2-d FFT of Complex data.
  public FFT2d(double inputRe[], double inputIm[], int dimx,int dimy) {
    // First make sure inputRe & inputIm are of the same length.

    

      dataRe = new double[dimy][dimx];
      dataIm = new double[dimy][dimx];

      for (int i = 0; i < dimy; i++)
        for (int j = 0; j < dimx; j++) {
          dataRe[i][j] = inputRe[i * dimx + j];
          dataIm[i][j] = inputIm[i * dimx + j];
        }

      // Calculate FFT for each row of the data.
      FFT1d fft1 = new FFT1d(dimx);
      for (int i = 0; i < dimy; i++){
        fft1.fft(dataRe[i], dataIm[i]);
               //System.out.println("i du data : "+i);
}
      // Tranpose data.
      // Calculate FFT for each column of the data.
      double temRe[][] = transpose(dataRe,dimx,dimy);
      double temIm[][] = transpose(dataIm,dimx,dimy);

      FFT1d fft2 = new FFT1d(dimy);
      for (int j = 0; j < dimx; j++){
         //System.out.println("j du tem : "+j);
        fft2.fft(temRe[j], temIm[j]);
}
      // Tranpose data.
      // Copy the result to input[], so the output can be
      // returned in the input array.
      for (int i = 0; i < dimy; i++)
        for (int j = 0; j < dimx; j++) {
          inputRe[i* dimx +j ] = temRe[j][i];
          inputIm[i*dimx + j] = temIm[j][i];
        }
    }
  

  // Transpose matrix input.
  private double[][] transpose(double[][] input,int dimx,int dimy) {
    double[][] output = new double[dimy][dimx]; // ne marchera que pour les carrées

    for (int j = 0; j < dimx; j++){
      for (int i = 0; i < dimy; i++){
        output[j][i] = input[i][j];
}
}
    return output;
  } // End of function transpose().


}
